#!/usr/bin/perl

use warnings "all";
use strict;

unless (defined($ARGV[0])) {print STDERR "Compares two matrices for equal sets"; exit 1;}

my %in;
open(X,"<$ARGV[0]") || die("Could not open file: '$ARGV[0]'\n");
while(<X>) {
	chomp;
	if ($_ =~ /^#/) {next;}
	
	my @all;
	my @data = split(/\s+/,$_);
	shift(@data);shift(@data);shift(@data);
	foreach (@data) {
		if ($_ eq "*") {next;}
		push(@all,split(/,/,$_));
	}

	$in{join(" ",sort(@all))} = 1;
}
close(X);

open(X,"<$ARGV[1]") || die("Could not open file: '$ARGV[1]'\n");
my $num = 0;
my $both = 0;
while(<X>) {
	chomp;
	if ($_ =~ /^#/) {next;}
	$num++;
	my @all;	
	my @data = split(/\s+/,$_);
	shift(@data);shift(@data);shift(@data);
	foreach (@data) {
		if ($_ eq "*") {next;}
		push(@all,split(/,/,$_));
	}

	my $me = join(" ",sort(@all));
	
	if (defined($in{$me})) {$both++;}

}
close(X);

if ((scalar(keys %in)-$both) > 0 || ($num-$both) > 0) {
	print " Match: $both\n";
	print " Additional: ".(scalar(keys %in)-$both)."\n";
	print " Missed: ".($num-$both)."\n";
	print STDERR "Test: failed!\n";

	exit 1;
}
else {
	print "Test: OK\n";
}


